Page MenuHomePhabricator

[ASTMatchers] extract public matchers from const-analysis into own patch
ClosedPublic

Authored by JonasToth on Sep 13 2020, 10:39 AM.

Details

Summary

The analysis for const-ness of local variables required a view generally useful
matchers that are extracted into its own patch.

They are decompositionDecl and forEachArgumentWithParamType, that works
for calls through function pointers as well.

This is a reupload of https://reviews.llvm.org/D72505, that already landed,
but had to be reverted due to a GCC crash on powerpc
(https://reviews.llvm.org/rG4c48ea68e491cb42f1b5d43ffba89f6a7f0dadc4)

Because this took a long time to adress, i decided to redo this patch and
have a clean workflow.
I try to coordinate with someone that has a PPC to apply this patch and
test for the crash. If everything is fine, I intend to just commit.
If the crash is still happening, i hope to at least find the cause.

Diff Detail

Event Timeline

JonasToth created this revision.Sep 13 2020, 10:39 AM
Herald added a project: Restricted Project. · View Herald TranscriptSep 13 2020, 10:39 AM
JonasToth requested review of this revision.Sep 13 2020, 10:39 AM
  • fix left over merge marker and one formatting problem
JonasToth updated this revision to Diff 291592.Sep 14 2020, 9:14 AM
  • fix compilation error from removed brace
This revision was not accepted when it landed; it landed in state Needs Review.Sep 15 2020, 12:08 PM
This revision was landed with ongoing or failed builds.
This revision was automatically updated to reflect the committed changes.
ro added a subscriber: ro.

As described in D87825, this patch broke Debug builds on sparcv9-sun-solaris2.11 and amd64-pc-solaris2.11.

In D87588#2278948, @ro wrote:

As described in D87825, this patch broke Debug builds on sparcv9-sun-solaris2.11 and amd64-pc-solaris2.11.

Thank you for reporting this issue. I it is fixed now: https://reviews.llvm.org/rGf0546173fa4bdde03ecb21a174fcaa8a6490adbd (thanks for that!)